<template>
  <div id="app">
    <input
      type="text"
      v-model="filter"
      placeholder="filter"
    >

    <div>Filter: {{ filter }}</div>

    <br><br>

    <button @click="resetFilter">
      Reset filter
    </button>

    <br><br>

    <ArticlePreviewList :articles="filteredArticles" />
  </div>
</template>

<script>
  import ArticlePreviewList from './components/08 ArticlePreviewList'

  export default {
    name: 'app',

    components: {
      ArticlePreviewList
    },

    data() {
      return {
        articles: [
          {
            title: 'my first card',
            date: '2019-06-01T12:24:46+02:00',
            abstract: 'First Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto corporis dolorum eveniet neque. Aliquid aperiam dicta dolores ducimus ex ipsam, magnam, molestiae, mollitia numquam quasi quo sequi temporibus ullam? Corporis!'
          },
          {
            title: 'my second card',
            date: '2019-05-31T23:24:46+02:00',
            abstract: 'Second Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto corporis dolorum eveniet neque. Aliquid aperiam dicta dolores ducimus ex ipsam, magnam, molestiae, mollitia numquam quasi quo sequi temporibus ullam? Corporis!'
          },
          {
            title: 'my third card',
            abstract: 'Third Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto corporis dolorum eveniet neque. Aliquid aperiam dicta dolores ducimus ex ipsam, magnam, molestiae, mollitia numquam quasi quo sequi temporibus ullam? Corporis!'
          },
          {
            title: 'my fourth card',
            date: '2019-03-31T23:24:46+02:00',
            abstract: 'Third Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto corporis dolorum eveniet neque. Aliquid aperiam dicta dolores ducimus ex ipsam, magnam, molestiae, mollitia numquam quasi quo sequi temporibus ullam? Corporis!'
          }
        ],

        filter: ''
      }
    },

    computed: {
      filteredArticles() {
        return this.articles.filter(article => article.title.indexOf(this.filter) > -1)
      }
    },

    methods: {
      resetFilter() {
        this.filter = ''
      }
    }
  }
</script>

<style>
  #app {
    font-family: 'Avenir', Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    margin-top: 60px;
  }
</style>
